/* $Id$ */
ZComponents.localeInfo =
{
	"br": {
		"days": ["Sul", "Lun", "Meurzh", "Mercʼher", "Yaou", "Gwener", "Sadorn"],
		"months": ["Genver","Cʼhwevrer","Meurzh","Ebrel","Mae","Mezheven","Gouere","Eost","Gwengolo","Here","Du","Kerzu"],
		"monthsAbbreviated": ["Gen.","Cʼhwe.","Meur.","Ebr.","Mae","Mezh.","Goue.","Eost","Gwen.","Here","Du","Kzu."],
		"daysAbbreviated": ["Sul","Lun","Meu.","Mer.","Yaou","Gwe.","Sad."],
		"dateFormat": {
			"short": "yyyy-MM-dd",
			"medium": "yyyy MMM d",
			"long": "yyyy MMMM d",
			"full": "yyyy MMMM d, dddd"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "yyyy MMM d HH:mm:ss z",
			"medium": "yyyy MMM d HH:mm:ss z",
			"long": "yyyy MMMM d, dddd HH:mm",
			"full": "yyyy MMMM d, dddd HH:mm"
		},
		"firstDayOfWeek": 0
	},
	"ca-IT": {
		"daysAbbreviated": [ "dg.","dl.","dt.","dc.","dj.","dv.","ds."],
		"days": [ "diumenge","dilluns","dimarts","dimecres","dijous","divendres","dissabte"],
		"months": [ "de gener","de febrer","de març", "d’abril","de maig", "de juny","de juliol", "d’agost","de setembre","d’octubre","de novembre","de desembre"],
		"monthsAbbreviated": ["de gen.", "de febr.", "de març","d’abr.","de maig", "de juny", "de jul.", "d’ag.", "de set.", "d’oct.", "de nov.", "de des."],
		"dateFormat": {
			"short" : "d/M/yy",
			"medium": "d/M/yyyy",
			"long": "d MMMM 'de' yyyy",
			"full": "dddd d MMMM 'de' yyyy"	
		},
		"timeFormat": {
			"short": "H:mm",
			"medium": "H:mm:ss",
			"long": "H:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d/M/yyyy,  H:mm:ss z",
			"medium": "d/M/yyyy,  H:mm:ss z",
			"long": "d/M/yyyy,  H:mm:ss z",
			"full": "d/M/yyyy,  H:mm:ss z"
		},
		"firstDayOfWeek": 1
	},
	"da": {
		"days": ["søndag", "mandag", "tirsdag","onsdag", "torsdag", "fredag", "lørdag"],
		"months": ["января", "февраля", "марта", "апреля", "мая", "июня","июля", "августа", "сентября", "октября", "ноября", "декабря"],
		"monthsAbbreviated": ["янв.", "февр.", "мар.", "апр.", "мая", "июн.", "июл.", "авг.", "сент.", "окт.", "нояб.", "дек."],
		"daysAbbreviated": ["søn.","man.","tir.","ons.","tor.","fre.","lør."],
		"dateFormat": {
			"short": "d/M/yyyy",
			"medium": "d. MMM yyyy",
			"long": "d. MMMM yyyy",
			"full": "dddd d. MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH.mm",
			"medium": "HH.mm.ss",
			"long": "HH.mm.ss z"
		},
		"dateTimeFormat": {
			"short": "d. MMM yyyy HH.mm.ss z",
			"medium": "d. MMM yyyy HH.mm.ss z",
			"long": "dddd d. MMMM yyyy HH.mm",
			"full": "dddd d. MMMM yyyy HH.mm"
		}
	},
	"de": {
		"monthsAbbreviated": ["Jan.","Feb.","März","Apr.","Mai","Juni","Juli","Aug.","Sep.","Okt.","Nov.","Dez."],
		"months": ["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],
		"days": [ "Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],
		"daysAbbreviated": ["So.","Mo.","Di.","Mi.","Do.","Fr.","Sa."],
		"dateFormat" : {
			"short": "dd.MM.yy",
			"medium": "dd.MM.yyyy",
			"long": "d. MMMM yyyy",
			"full": "dddd, d. MMMM yyyy"
		},
		"timeFormat": {
			"short" : "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short" : "dd.MM.yyyy HH:mm:ss z",
			"medium": "dd.MM.yyyy HH:mm:ss z",
			"long": "dddd, d. MMMM yyyy HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"de-IT": {
		"days": [ "Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],
		"months": ["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],
		"monthsAbbreviated": ["Jan.","Feb.","März","Apr.","Mai","Juni","Juli","Aug.","Sep.","Okt.","Nov.","Dez."],
		"daysAbbreviated": ["So.","Mo.","Di.","Mi.","Do.","Fr.","Sa."],
		"dateFormat": {
			"short": "dd.MM.yy",
			"medium": "dd.MM.yyyy",
			"long": "d. MMMM yyyy",
			"full": "dddd, d. MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "dd.MM.yyyy, HH:mm:ss z",
			"medium": "dd.MM.yyyy, HH:mm:ss z",
			"long": "dddd, d. MMMM yyyy 'um' HH:mm",
			"full": "dddd, d. MMMM yyyy 'um' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"de-BE": {
		"daysAbbreviated": ["So.","Mo.","Di.","Mi.", "Do.","Fr.","Sa."],
		"days": ["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],
		"months": [ "Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],
		"monthsAbbreviated":[ "Jan.","Feb.","März","Apr.","Mai","Juni" ,"Juli", "Aug.", "Sep.","Okt.","Nov.","Dez."],
		"dateFormat": {
			"short": "dd.MM.yy",
			"medium": "dd.MM.yyyy",
			"long": "d. MMMM yyyy",
			"full": "dddd, d. MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "dd.MM.yyyy, HH:mm",
			"medium": "dd.MM.yyyy, HH:mm",
			"long": "dddd, d. MMMM yyyy 'um' HH:mm",
			"full": "dddd, d. MMMM yyyy 'um' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"en-GB": {
		"daysAbbreviated": ["Sun","Mon","Tue","Wed","Thu","Fri", "Sat"],
		"days": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		"months": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		"monthsAbbreviated": ["Jan","Feb","Mar", "Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],
		"dateFormat": {
			"short" : "dd/MM/yyyy",
			"medium" : "d MMM yyyy",
			"long" : "d MMMM yyyy",
			"full": "dddd, d MMMM yyyy",
			"other": {
				"dateMonth" : "d MMMM",
				"yearMonth" : "MMMM yyyy"
			}
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"  	
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy, HH:mm:ss z",
			"medium": "d MMM yyyy, HH:mm:ss z",
			"long": "dddd, d MMMM yyyy 'at' HH:mm",
			"full": "dddd, d MMMM yyyy 'at' HH:mm"
		},
		"numberFormat": {
			"thousandSeparator": ",",
			"decimalSeparator" : "."
		},
		"currency":{
			"code"  : "GBP",
			"name"  : "Pound sterling",
			"symbol": "\u00a3"
		},
		"firstDayOfWeek": 1	
	},
	"en-HK": {
		"daysAbbreviated": ["Sun","Mon","Tue","Wed","Thu","Fri", "Sat"],
		"days": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		"months": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		"monthsAbbreviated": ["Jan","Feb","Mar", "Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],
		"dateFormat": {
			"short": "d/M/yy",
			"medium": "d MMM, yyyy",
			"long": "d MMMM, yyyy",
			"full": "dddd, d MMMM, yyyy"
		},
		"timeFormat": {
			"short": "h:mm tt",
			"medium": "h:mm:ss tt",
			"long": "h:mm:ss tt z"
		},
		"dateTimeFormat": {
			"short": "d MMM, yyyy, h:mm:ss tt z",
			"medium": "d MMM, yyyy, h:mm:ss tt z",
			"long": "dddd, d MMMM, yyyy 'at' h:mm tt",
			"full": "dddd, d MMMM, yyyy 'at' h:mm tt"
		},
		"firstDayOfWeek": 0
	},
	"en-SE":{
		"daysAbbreviated": ["Sun","Mon","Tue","Wed","Thu","Fri", "Sat"],
		"days": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		"months": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		"monthsAbbreviated": ["Jan","Feb","Mar", "Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],
		"dateFormat": {
			"short": "yyyy-MM-dd",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd, d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM, yyyy, h:mm:ss tt z",
			"medium": "d MMM, yyyy, h:mm:ss tt z",
			"long": "dddd, d MMMM, yyyy 'at' h:mm tt",
			"full": "dddd, d MMMM, yyyy 'at' h:mm tt"
		},
		"firstDayOfWeek": 1
	},
	"en-US": {
		"daysAbbreviated": ["Sun","Mon","Tue","Wed","Thu","Fri", "Sat"],
		"days": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		"months": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		"monthsAbbreviated": ["Jan","Feb","Mar", "Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],
		"dateFormat": {
			"short": "M/d/yyyy",
			"medium": "MMM d, yyyy",
			"long": "MMMM d, yyyy",
			"full": "dddd, MMMM d, yyyy"
		},
		"timeFormat": {
			"short": "h:mm tt",
			"medium": "h:mm:ss tt",
			"long": "hh:mm:ss tt"
		},
		"dateTimeFormat": {
			"short": "MMM d, yyyy, hh:mm:ss tt",
			"medium": "MMM d, yyyy, hh:mm:ss tt",
			"long": "dddd, MMMM d, yyyy 'at' h:mm tt",
			"full": "dddd, MMMM d, yyyy 'at' h:mm tt"
		},
		"numberFormat": {
			"thousandSeparator": ",",
			"decimalSeparator" : "."
		},
		"currency":{
			"code"  : "USD",
			"name"  : "United States Dollar",
			"symbol": "\u0024"
		},
		"firstDayOfWeek": 0
	},
	"en-IN": {
		"daysAbbreviated": ["Sun","Mon","Tue","Wed","Thu","Fri", "Sat"],
		"days": ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		"months": ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		"monthsAbbreviated": ["Jan","Feb","Mar", "Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],
		"dateFormat": {
			"short": "dd/M/yyyy",
			"medium": "dd-MMM-yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "h:mm tt",
			"medium": "h:mm:ss tt",
			"long": "h:mm:ss tt z"
		},
		"dateTimeFormat": {
			"short": "dd-MMM-yyyy, h:mm:ss tt z",
			"medium": "dd-MMM-yyyy, h:mm:ss tt z",
			"long": "dddd d MMMM yyyy 'at' h:mm tt",
			"full": "dddd d MMMM yyyy 'at' h:mm tt"
		},
		"firstDayOfWeek": 0
	},
	"es": {
		"daysAbbreviated": ["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],
		"monthsAbbreviated": ["ene.","feb.","mar.","abr.","may.","jun.","jul.","ago.","sept.","oct.","nov.","dic."],
		"months": ["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],
		"days": ["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],
		"dateFormat": {
			"short": "d/M/yy",
			"medium": "d/M/yyyy",
			"long": "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "H:mm",
			"medium": "H:mm:ss",
			"long": "H:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d/M/yyyy, H:mm:ss z",
			"medium": "d/M/yyyy, H:mm:ss z",
			"long": "dddd, d 'de' MMMM 'de' yyyy H:mm",
			"full": "dddd, d 'de' MMMM 'de' yyyy H:mm"
		},
		"firstDayOfWeek": 1
	},	
	"es-AR": {
		"days": ["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],
		"months": ["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],
		"monthsAbbreviated": ["ene.","feb.","mar.","abr.","may.","jun.","jul.","ago.","sept.","oct.","nov.","dic."],
		"daysAbbreviated": ["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],
		"dateFormat": {
			"short": "d/M/yy",
			"medium": "d MMM yyyy",
			"long": "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd, d 'de' MMMM 'de' yyyy, HH:mm",
			"full": "dddd, d 'de' MMMM 'de' yyyy, HH:mm"
		}
	},
	"es-NI": {
		"days": ["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],
		"months": ["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],
		"monthsAbbreviated": ["ene.","feb.","mar.","abr.","may.","jun.","jul.","ago.","sept.","oct.","nov.","dic."],
		"daysAbbreviated": ["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],
		"dateFormat": {
			"short": "dd/MM/yy",
			"medium": "d/M/yyyy",
			"long": "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d/M/yyyy HH:mm:ss z",
			"medium": "d/M/yyyy HH:mm:ss z",
			"long": "dddd, d 'de' MMMM 'de' yyyy, HH:mm",
			"full": "dddd, d 'de' MMMM 'de' yyyy, HH:mm"
		},
		"firstDayOfWeek": 0
	},
	"es-PR": {
		"daysAbbreviated" : ["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],
		"days": ["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],
		"monthsAbbreviated": ["ene.", "feb.", "mar.", "abr.", "may.", "jun.", "jul.", "ago.", "sep.", "oct.","nov.", "dic."],
		"months": ["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],
		"dateFormat": {
			"short":  "MM/dd/yy",
			"medium": "MM/dd/yyyy",
			"long":  "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "h:mm tt",
			"medium": "h:mm:ss tt",
			"long": "h:mm:ss tt z"
		},
		"dateTimeFormat": {
			"short": "MM/dd/yyyy h:mm:ss tt z",
			"medium": "MM/dd/yyyy h:mm:ss tt z",
			"long": "dddd, d 'de' MMMM 'de' yyyy, h:mm tt",
			"full": "dddd, d 'de' MMMM 'de' yyyy, h:mm tt"
		},
		"firstDayOfWeek": 0
	},
	"es-SV": {
		"daysAbbreviated" : ["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],
		"days": ["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],
		"monthsAbbreviated": ["ene.", "feb.", "mar.", "abr.", "may.", "jun.", "jul.", "ago.", "sep.", "oct.","nov.", "dic."],
		"months": ["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],
		"dateFormat": {
			"short": "dd/MM/yy",
			"medium": "d/M/yyyy",
			"long": "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d/M/yyyy HH:mm:ss z",
			"medium": "d/M/yyyy HH:mm:ss z",
			"long": "dddd, d 'de' MMMM 'de' yyyy, HH:mm",
			"full": "dddd, d 'de' MMMM 'de' yyyy, HH:mm"
		},
		"firstDayOfWeek": 0
	},
	"fr": {
		"daysAbbreviated": [ "dim.","lun.","mar.","mer.","jeu.","ven.","sam."],
		"days": ["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"],
		"monthsAbbreviated": [ "janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],
		"months": ["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],
		"dateFormat": {
			"short": "dd/MM/yyyy",
			"medium": "d MMM yyyy",
			"long":	"d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd d MMMM yyyy 'à' HH:mm",
			"full":"dddd d MMMM yyyy 'à' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"fr-BE": {
		"months": ["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],
		"monthsAbbreviated": ["janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],
		"daysAbbreviated": ["dim.","lun.","mar.","mer.","jeu.","ven.","sam."],
		"days": ["dimanche","lundi","mardi", "mercredi", "jeudi", "vendredi", "samedi"],
		"dateFormat": {
			"short": "d/MM/yy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full":  "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat":{ 
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "dddd d MMMM yyyy 'à' HH:mm",
			"long": "dddd d MMMM yyyy 'à' HH:mm",
			"full": "dddd d MMMM yyyy 'à' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"fr-BL": {
		"days": ["dimanche","lundi","mardi", "mercredi", "jeudi", "vendredi", "samedi"],
		"months": ["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],
		"monthsAbbreviated":  ["janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],
		"daysAbbreviated": ["dim.","lun.","mar.","mer.","jeu.","ven.","sam."],
		"dateFormat": {
			"short": "dd/MM/yyyy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "dddd d MMMM yyyy 'à' HH:mm",
			"long": "dddd d MMMM yyyy 'à' HH:mm",
			"full": "dddd d MMMM yyyy 'à' HH:mm"
		}
	},
	"fr-HT": {
		"days": ["dimanche","lundi","mardi", "mercredi", "jeudi", "vendredi", "samedi"],
		"months":  ["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],
		"monthsAbbreviated": ["janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],
		"daysAbbreviated": ["dim.","lun.","mar.","mer.","jeu.","ven.","sam."],
		"dateFormat": {
			"short": "dd/MM/yyyy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd d MMMM yyyy 'à' HH:mm",
			"full": "dddd d MMMM yyyy 'à' HH:mm"
		}
	},
	"ha-GH":{ 
		"days": [ "Lahadi","Litinin","Talata","Laraba","Alhamis","Jummaʼa","Asabar"],
		"months": [ "Janairu","Faburairu","Maris","Afirilu","Mayu", "Yuni", "Yuli", "Agusta", "Satumba", "Oktoba", "Nuwamba", "Disamba"],
		"monthsAbbreviated": [ "Jan","Fab","Mar", "Afi", "May","Yun","Yul","Agu","Sat","Okt","Nuw","Dis"],
		"daysAbbreviated": ["Lah","Lit","Tal","Lar","Alh","Jum","Asa"],
		"dateFormat": {
			"short": "d/M/yy",
			"medium": "d MMM, yyyy",
			"long": "d MMMM, yyyy",
			"full": "dddd, d MMMM, yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM, yyyy HH:mm:ss z",
			"medium": "d MMM, yyyy HH:mm:ss z",
			"long": "dddd, d MMMM, yyyy HH:mm",
			"full": "dddd, d MMMM, yyyy HH:mm"
		}
	},
	"hr-BA": {
		"daysAbbreviated": [ "ned","pon","uto","sri","čet","pet","sub"],
		"days": ["nedjelja","ponedjeljak","utorak","srijeda","četvrtak","petak","subota"],
		"monthsAbbreviated": [ "sij","velj","ožu","tra","svi","lip","srp","kol","ruj","lis","stu","pro"],
		"months": [ "siječnja","veljače","ožujka","travnja","svibnja","lipnja","srpnja","kolovoza","rujna","listopada","studenoga","prosinca"],
		"dateFormat": {
			"short": "dd. MM. yyyy.",
			"medium": "d. MMM yyyy.",
			"long": "d. MMMM yyyy.",
			"full": "dddd, d. MMMM yyyy."
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss", 
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d. MMM yyyy. HH:mm:ss z",
			"medium": "d. MMM yyyy. HH:mm:ss z",
			"long": "dddd, d. MMMM yyyy. 'u' HH:mm",
			"full": "dddd, d. MMMM yyyy. 'u' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"nl": {
		"daysAbbreviated": [ "ned","pon","uto","sri","čet","pet","sub"],
		"days": ["nedjelja","ponedjeljak","utorak","srijeda","četvrtak","petak","subota"],
		"monthsAbbreviated": [ "sij","velj","ožu","tra","svi","lip","srp","kol","ruj","lis","stu","pro"],
		"months": [ "siječnja","veljače","ožujka","travnja","svibnja","lipnja","srpnja","kolovoza","rujna","listopada","studenoga","prosinca"],
		"dateFormat": {
			"short": "dd-MM-yy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss", 
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd d MMMM yyyy 'om' HH:mm",
			"full": "dddd d MMMM yyyy 'om' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"nl-AW": {
		"days": ["zondag","maandag","dinsdag","woensdag","donderdag","vrijdag","zaterdag"],
		"months": ["januari", "februari", "maart", "april", "mei", "juni", "juli", "augustus", "september", "oktober", "november", "december"],
		"monthsAbbreviated": ["jan.", "feb.", "mrt.", "apr.", "mei", "jun.", "jul.", "aug.", "sep.", "okt.","nov.", "dec."],
		"daysAbbreviated":  ["zo", "ma", "di", "wo", "do", "vr", "za"],
		"dateFormat": {
			"short": "dd-MM-yy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss", 
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd d MMMM yyyy 'om' HH:mm",
			"full": "dddd d MMMM yyyy 'om' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"nl-SR": {
		"days": ["zondag","maandag","dinsdag","woensdag","donderdag","vrijdag","zaterdag"],
		"months": ["januari", "februari", "maart", "april", "mei", "juni", "juli", "augustus", "september", "oktober", "november", "december"],
		"monthsAbbreviated": ["jan.", "feb.", "mrt.", "apr.", "mei", "jun.", "jul.", "aug.", "sep.", "okt.","nov.", "dec."],
		"daysAbbreviated": ["zo", "ma", "di", "wo", "do", "vr", "za"],
		"dateFormat": {
			"short": "dd-MM-yy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss", 
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd d MMMM yyyy 'om' HH:mm",
			"full": "dddd d MMMM yyyy 'om' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"pl": {
		"days": [ "niedziela","poniedziałek","wtorek","środa","czwartek","piątek","sobota"],
		"months": ["stycznia","lutego","marca","kwietnia","maja","czerwca","lipca","sierpnia","września","października","listopada","grudnia"],
		"monthsAbbreviated": ["sty", "lut", "mar", "kwi", "maj", "cze", "lip", "sie", "wrz", "paź", "lis", "gru"],
		"daysAbbreviated": [ "niedz.", "pon.", "wt.", "śr.", "czw.", "pt.", "sob." ],
		"dateFormat": {
			"short": "dd.MM.yyyy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd, d MMMM y"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy, HH:mm:ss z",
			"medium": "d MMM yyyy, HH:mm:ss z",
			"long": "d MMM yyyy HH:mm:ss z",
			"full": "d MMM yyyy, HH:mm:ss z"
		},
		"firstDayOfWeek": 1
	},
	"pt": {
		"daysAbbreviated": ["dom","seg","ter","qua","qui","sex","sáb"],
		"days": ["domingo","segunda-feira","terça-feira","quarta-feira","quinta-feira","sexta-feira","sábado"],
		"monthsAbbreviated": [ "jan","fev","mar","abr","mai","jun","jul","ago","set","out","nov","dez"],
		"months": [ "janeiro", "fevereiro", "março", "abril", "maio", "junho", "julho", "agosto", "setembro", "outubro", "novembro", "dezembro"],
		"dateFormat": {
			"short": "dd/MM/yyyy",
			"medium": "dd/MM/yyyy",
			"long": "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "HH:mm", 
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "dd/MM/yyyy HH:mm:ss z",
			"medium": "dd/MM/yyyy HH:mm:ss z",
			"long": "dddd, d 'de' MMMM 'de' yyyy HH:mm",
			"full": "dddd, d 'de' MMMM 'de' yyyy HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"pt-CV": {
		"days": ["domingo","segunda-feira","terça-feira","quarta-feira","quinta-feira","sexta-feira","sábado"],
		"months": [ "janeiro", "fevereiro", "março", "abril", "maio", "junho", "julho", "agosto", "setembro", "outubro", "novembro", "dezembro"],
		"monthsAbbreviated":[ "jan","fev","mar","abr","mai","jun","jul","ago","set","out","nov","dez"],
		"daysAbbreviated": [ "domingo","segunda","terça","quarta","quinta","sexta","sábado"],
		"dateFormat": {
			"short": "d/M/yyyy",
			"medium": "dd/MM/yyyy",
			"long": "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "dd/MM/yyyy, HH:mm:ss z",
			"medium": "dd/MM/yyyy, HH:mm:ss z",
			"long": "dddd, d 'de' MMMM 'de' yyyy 'às' HH:mm",
			"full": "dddd, d 'de' MMMM 'de' yyyy 'às' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"pt-TL" :{
		"days": ["domingo","segunda-feira","terça-feira","quarta-feira","quinta-feira","sexta-feira","sábado"],
		"months":[ "janeiro", "fevereiro", "março", "abril", "maio", "junho", "julho", "agosto", "setembro", "outubro", "novembro", "dezembro"],
		"monthsAbbreviated": [ "jan","fev","mar","abr","mai","jun","jul","ago","set","out","nov","dez"],
		"daysAbbreviated": [ "domingo","segunda","terça","quarta","quinta","sexta","sábado"],
		"dateFormat": {
			"short": "d/M/yyyy",
			"medium": "dd/MM/yyyy",
			"long": "d 'de' MMMM 'de' yyyy",
			"full": "dddd, d 'de' MMMM 'de' yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "dd/MM/yyyy, HH:mm:ss z",
			"medium": "dd/MM/yyyy, HH:mm:ss z",
			"long": "dddd, d 'de' MMMM 'de' yyyy 'às' HH:mm",
			"full": "dddd, d 'de' MMMM 'de' yyyy 'às' HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"ru": {
		"days": ["воскресенье","понедельник","вторник","среда","четверг","пятница","суббота"],
		"months": ["января","февраля","марта","апреля","мая","июня","июля","августа","сентября","октября","ноября","декабря"],
		"monthsAbbreviated": ["янв.","февр.","мар.","апр.","мая","июн.","июл.","авг.","сент.","окт.","нояб.","дек."],
		"daysAbbreviated": ["вс","пн","вт","ср","чт","пт","сб"],
		"dateFormat": {
			"short": "dd.MM.yyyy",
			"medium": "d MMM yyyy 'г'.",
			"long": "d MMMM yyyy 'г'.",
			"full": "dddd, d MMMM yyyy 'г'."
		},
		"timeFormat": {
			"short": "H:mm",
			"medium": "H:mm:ss",
			"long": "H:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy 'г'., H:mm:ss z",
			"medium": "d MMM yyyy 'г'., H:mm:ss z",
			"long": "dddd, d MMMM yyyy 'г'., H:mm",
			"full": "dddd, d MMMM yyyy 'г'., H:mm"
		},
		"firstDayOfWeek": 1
	},
	"ru-KG": {
		"days": [ "воскресенье","понедельник","вторник","среда","четверг","пятница","суббота"],
		"months": [ "января","февраля","марта","апреля","мая","июня","июля","августа","сентября","октября","ноября","декабря"],
		"monthsAbbreviated": [ "янв.", "февр.","мар.","апр.","мая","июн.","июл.","авг.","сент.","окт.","нояб.","дек."],
		"daysAbbreviated": [ "вс","пн","вт","ср","чт","пт","сб"],
		"dateFormat": {
			"short": "dd.MM.yyyy",
			"medium": "d MMM yyyy 'г'.",
			"long": "d MMMM yyyy 'г'.",
			"full": "dddd, d MMMM yyyy 'г'."
		},
		"timeFormat": {
			"short": "H:mm",
			"medium": "H:mm:ss",
			"long": "H:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy 'г'., H:mm:ss z",
			"medium": "d MMM yyyy 'г'., H:mm:ss z",
			"long": "d MMM yyyy 'г'., H:mm:ss z",
			"full": "d MMM yyyy 'г'., H:mm:ss z"
		},
		"firstDayOfWeek": 1
	},
	"ru-UA": {
		"days": ["воскресенье","понедельник","вторник","среда","четверг","пятница","суббота"],
		"months": [ "января","февраля","марта","апреля","мая","июня","июля","августа","сентября","октября","ноября","декабря"],
		"monthsAbbreviated": ["янв.","февр.","мар.","апр.","мая","июн.","июл.","авг.","сент.","окт.","нояб.","дек."],
		"daysAbbreviated": ["вс","пн","вт","ср","чт","пт","сб" ],
		"dateFormat": {
			"short": "dd.MM.yyyy",
			"medium": "d MMM yyyy 'г'.",
			"long": "d MMMM yyyy 'г'.",
			"full": "dddd, d MMMM yyyy 'г'."
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy 'г'., HH:mm:ss z",
			"medium": "d MMM yyyy 'г'., HH:mm:ss z",
			"long": "dddd, d MMMM yyyy 'г'., HH:mm",
			"full": "dddd, d MMMM yyyy 'г'., HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"sv": {
		"daysAbbreviated": ["sön","mån","tis","ons","tors","fre","lör"],
		"months": ["januari","februari","mars","april","maj","juni","juli","augusti","september","oktober","november","december"],
		"monthsAbbreviated": ["jan.","feb.","mars","apr.","maj","juni","juli","aug.","sep.","okt.","nov.","dec."],
		"days": [ "söndag","måndag","tisdag","onsdag","torsdag","fredag","lördag"],
		"dateFormat": {
			"short": "yyyy-MM-dd",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "dddd d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd d MMMM yyyy HH:mm",
			"full": "dddd d MMMM yyyy HH:mm"
		},
		"firstDayOfWeek": 0
	},
	"tr": {
		"days": ["Pazar","Pazartesi","Salı","Çarşamba","Perşembe","Cuma","Cumartesi"],
		"months": ["Ocak","Şubat","Mart","Nisan","Mayıs","Haziran","Temmuz","Ağustos","Eylül","Ekim","Kasım","Aralık"],
		"monthsAbbreviated": ["Oca","Şub","Mar","Nis","May","Haz","Tem","Ağu","Eyl","Eki","Kas","Ara"],
		"daysAbbreviated": ["Paz", "Pzt", "Sal", "Çar", "Per", "Cum", "Cmt"],
		"dateFormat": {
			"short": "d.MM.yyyy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy",
			"full": "d MMMM yyyy"
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "d MMMM yyyy HH:mm",
			"full": "d MMMM yyyy HH:mm"
		},
		"firstDayOfWeek": 1
	},
	"uk": {
		"daysAbbreviated": ["нд","пн","вт","ср","чт","пт","сб"],
		"days":["неділя","понеділок","вівторок","середа","четвер","пʼятниця","субота"],
		"months": [ "січня", "лютого","березня", "квітня", "травня", "червня", "липня", "серпня","вересня", "жовтня","листопада", "грудня"],
		"monthsAbbreviated": [ "січ.","лют.","бер.","квіт.","трав.","черв.","лип.","серп.","вер.","жовт.","лист.","груд."],
		"dateFormat": {
			"short": "dd.MM.yy",
			"medium": "d MMM yyyy",
			"long": "d MMMM yyyy 'р'.",
			"full": "dddd, d MMMM yyyy 'р'."
		},
		"timeFormat": {
			"short": "HH:mm",
			"medium": "HH:mm:ss",
			"long": "HH:mm:ss z"
		},
		"dateTimeFormat": {
			"short": "d MMM yyyy HH:mm:ss z",
			"medium": "d MMM yyyy HH:mm:ss z",
			"long": "dddd, d MMMM yyyy 'р'. HH:mm",
			"full": "dddd, d MMMM yyyy 'р'. HH:mm"
		}
	}
}
